<template>
  <v-app class="facilitator-dashboard">
    <v-app-bar flat clipped-left app color="transparent" class="nav-bar">
      <v-app-bar-nav-icon
        class="hidden-md-and-up"
        @click.stop="drawer = !drawer"
      ></v-app-bar-nav-icon>
      <v-spacer></v-spacer>
      <v-menu offset-y left bottom>
        <template v-slot:activator="{ on }">
          <v-btn icon v-on="on">
            <v-badge :content="1" :value="true" color="blue" overlap>
              <v-icon>far fa-bell</v-icon>
            </v-badge>
          </v-btn>
        </template>

        <!--        If there are notifications-->
        <v-card v-if="notifications.length" class="mx-auto" max-width="600">
          <v-card-text>
            <div class="ml-5">Notifications</div>

            <v-list subheader two-line>
              <v-list-item>
                <v-list-item-avatar>
                  <v-icon class="grey lighten-1" dark>
                    mdi-folder
                  </v-icon>
                </v-list-item-avatar>

                <v-list-item-content>
                  <v-list-item-title
                    v-text="'Alchocholic Circle'"
                  ></v-list-item-title>

                  <v-list-item-subtitle
                    @click="openNotification()"
                    v-text="'You have a meeting in 20 minutes.'"
                  ></v-list-item-subtitle>
                </v-list-item-content>

                <v-list-item-action>
                  <v-btn icon>
                    <v-icon color="grey lighten-1">fas fa-times</v-icon>
                  </v-btn>
                </v-list-item-action>
              </v-list-item>

              <v-divider inset></v-divider>
            </v-list>
          </v-card-text>

          <v-card-actions>
            <v-btn text color="deep-purple accent-4">
              Learn More about notifications
            </v-btn>
          </v-card-actions>
        </v-card>

        <!--        If there are no notifications-->
        <v-card v-else class="mx-auto" max-width="344">
          <v-card-text>
            <div class="mb-2">
              Notifications
              <span class="deep-purple--text accent-2 font-weight-bold ml-2 v-btn--absolute" style="top: 12px;">Beta</span>
            </div>
            <hr>
            <div class="mt-3">
              <h3 class="">
                No new notifications
              </h3>
            </div>
          </v-card-text>
        </v-card>
      </v-menu>

      <v-menu offset-y left bottom>
        <template v-slot:activator="{ on }">
          <v-btn icon v-on="on">
            <v-icon size="32">mdi-heart</v-icon>
          </v-btn>
        </template>
        <v-list>
          <v-list-item>
            <v-list-item-avatar>
              <v-avatar color="indigo" size="36">
                <span class="white--text headline">{{
                  user.firstName && user.firstName[0]
                }}</span>
              </v-avatar>
            </v-list-item-avatar>
            <v-list-item-content>
              <v-list-item-title
                >{{ user.firstName }} {{ user.lastName }}</v-list-item-title
              >
              <v-list-item-subtitle>{{ user.email }}</v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
        </v-list>
        <v-list>
          <v-list-item to="/facilitator" exact>
            <v-list-item-title>Dashboard</v-list-item-title>
          </v-list-item>
          <v-list-item to="/facilitator/account" exact>
            <v-list-item-title>Account</v-list-item-title>
          </v-list-item>
          <v-list-item to="/facilitator/notifications" exact>
            <v-list-item-title>
              Notifications
              <span class="deep-purple--text accent-2 font-weight-bold ml-2 v-btn--absolute v-snack--top">Beta</span>
            </v-list-item-title>
          </v-list-item>
          <v-divider />
          <v-list-item @click="logout" exact>
            <v-list-item-title>Sign Out</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-app-bar>

    <v-navigation-drawer
      :mini-variant="mini"
      float
      :permanent="$vuetify.breakpoint.mdAndUp"
      v-model="drawer"
      app
      class="left-menu"
    >
      <template v-slot:prepend>
        <v-list-item two-line>
          <v-list-item-avatar :size="mini ? 28 : 42">
            <v-img
              v-if="facilitatorProfile && facilitatorProfile.imageUrl"
              :src="facilitatorProfile && facilitatorProfile.imageUrl"
            />
            <span v-if="facilitatorProfile && !facilitatorProfile.imageUrl">{{
              facilitatorProfile.firstName
            }}</span>
          </v-list-item-avatar>

          <v-list-item-content>
            <v-list-item-title
              >{{ user.firstName | capitalize }}
              {{ user.lastName | capitalize }}</v-list-item-title
            >
            <v-list-item-subtitle>Logged In</v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
      </template>

      <v-divider></v-divider>
      <v-list>
        <v-list-item
          class="mb-4"
          active-class="side-menu-item-active"
          link
          exact
          to="/facilitator"
        >
          <v-list-item-icon>
            <v-icon>mdi-view-dashboard</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>Dashboard</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-list-item
          class="mb-4"
          active-class="side-menu-item-active"
          link
          exact
          to="/facilitator/groups"
        >
          <v-list-item-icon>
            <v-icon>mdi-google-circles-extended</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>Group Circles</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-list-item
          class="mb-4"
          active-class="side-menu-item-active"
          link
          exact
          to="/facilitator/profile"
        >
          <v-list-item-icon>
            <v-icon>mdi-account-outline</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>Profile</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-list-item
          class="mb-4"
          active-class="side-menu-item-active"
          link
          exact
          to="/facilitator/conversations"
        >
          <v-list-item-icon>
            <v-icon>mdi-chat</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>Conversations</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-list-item
          class="mb-4"
          active-class="side-menu-item-active"
          link
          exact
          to="/facilitator/integration"
        >
          <v-list-item-icon>
            <v-icon>mdi-transit-connection</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>Integration</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>

      <template v-slot:append>
        <div class="pa-2 text-center">
          <span class="title">{{ mini ? 'C' : 'Circle' }}</span>
        </div>
      </template>
    </v-navigation-drawer>

    <v-content app class="">
      <router-view />
    </v-content>
  </v-app>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import { Role } from '@/constants'

export default {
  name: 'FacilitatorDashboard',
  components: {},
  data: () => ({
    drawer: true,
    Role,
    mini: false
  }),
  head() {
    return {
      title: {
        inner: 'Facilitator Dashboard'
      }
    }
  },
  computed: {
    ...mapState('authentication', ['user']),
    ...mapState('facilitatorProfile', ['facilitatorProfile']),
    checkUserProfile() {
      return (
        this.facilitatorProfile &&
        (!this.facilitatorProfile.imageUrl ||
          this.facilitatorProfile.experiences.length === 0 ||
          !this.facilitatorProfile.title ||
          !this.facilitatorProfile.about)
      )
    },
    notifications() {
      return []
    }
  },
  mounted() {
    this.getMyCircles()
  },
  watch: {
    $route(to) {
      // react to route changes...
      this.mini = to.name === 'facilitator-conversations'
    }
  },
  methods: {
    ...mapActions('authentication', ['logout']),
    ...mapActions('facilitatorProfile', ['getMyCircles']),
    openNotification() {}
  }
}
</script>

<style lang="scss" scoped>
.facilitator-dashboard {
  .side-menu-item-active {
    background: transparent;
    border-right: 2px solid #f27561;
    &:before {
      background: none;
    }
  }
  .left-menu {
  }
  .nav-bar {
    .v-toolbar__content {
      border-bottom: 1px solid #e0e0e0;
    }
  }
}
</style>
